#include <dsound.h>
#include <dmotor.h>
#include <unistd.h>
#include <lnp/lnp.h>
#include <lnp/lnp-logical.h>
#include "komm.h"

void beep(int i) {
  static const note_t beepsound[] ={
	{ PITCH_G4, QUARTER },
	{ PITCH_END, 0 }
  };
  beepsound[0].pitch = i /*? PITCH_G3: PITCH_G4*/;
  dsound_play(beepsound);
}

typedef unsigned char byte;
#define BLINKTIME 100
volatile int villogni_kell;
pid_t pid_blinker_thread;
void blinker_thread()
{
  while(1)
  {
	  if(villogni_kell)
	  {
		motor_b_speed( MAX_SPEED );
		motor_b_dir( fwd );
	  }
	  msleep(BLINKTIME);
      motor_b_speed( 0);
	  motor_b_dir(off);
	  msleep(BLINKTIME);
  }
}

/* 	az uzenet mindig 'int' tipusu szam! */

#define MAX_UZENET 100
int uzenetsor[MAX_UZENET];
int uz_elso,uz_utolso;
int uz_db;

void uzenet_elkapo(byte * data, byte len, byte src)
{
	uzenetsor[ uz_utolso ] = *(int*)data;
	uz_utolso = (uz_utolso+1) % MAX_UZENET;
	uz_db++;
}

wakeup_t uzenet_jott_wakeup(wakeup_t w)
{
  return uz_db != 0;
}

int kivesz_uzenet()
{
  int uz = uzenetsor[ uz_elso ];
  uz_elso = (uz_elso+1) % MAX_UZENET;
  uz_db--;
  return uz;
}

wakeup_t uzenet_varo_timeout_wakeup(wakeup_t time)
{
  return uzenet_jott_wakeup(0) || (sys_time >= time);
}

int szakasz;
int irany = 0;
int main()
{
  lnp_logical_range(1);
  uz_elso = uz_utolso = uz_db = 0;
  lnp_addressing_set_handler( ELVESZETT_PORT, uzenet_elkapo );

  /* Villogtato thread inditasa: */
  pid_blinker_thread = 
	  execi( blinker_thread, 0 , 0, 2, DEFAULT_STACK_SIZE);
  villogni_kell=1;
  
  motor_a_speed( MAX_SPEED );

  szakasz=0;
  
  while(1)
  {
	motor_a_dir( irany ? fwd :rev );
	wait_event(uzenet_varo_timeout_wakeup, sys_time + 1500);
    if( uzenet_jott_wakeup(0) )
	{
		if( kivesz_uzenet() == NE_FOROGJ)
			break;
	}
	motor_a_dir(off);
	wait_event(uzenet_varo_timeout_wakeup, sys_time + 3000);
	if( uzenet_jott_wakeup(0) )
	{
		break;
	}
	szakasz++;
	if(szakasz > 9 )
	{ szakasz=0;
	  irany=1-irany;
	}
  }

  motor_a_dir(off);
  beep(PITCH_G5);


  while(1)
  {
	wait_event(uzenet_jott_wakeup, 0);
	if( kivesz_uzenet()==NE_VILLOGJ)
		villogni_kell = 0;
//	msleep(1000);
  }
}
